<template>
    <StackLayout @loaded="loaded" ref="main" iosOverflowSafeArea="false">
        <GridLayout :backgroundColor="backgroundColor" columns="40, *, 40"
            rows="40" @tap="toggle()" :class="'cp-header ' + (showPanel ? 'opened' : 'closed')"
            iosOverflowSafeArea="false">
            <GridLayout col="0" class="cp-icon" iosOverflowSafeArea="false">
                <Label :class="iconset" :text="icon | fonticon"
                    verticalAlignment="center" horizontalAlignment="center"
                    iosOverflowSafeArea="false" />
            </GridLayout>
            <GridLayout col="1" iosOverflowSafeArea="false">
                <Label :text="title" verticalAlignment="center"
                    horizontalAlignment="left" class="cp-title"
                    iosOverflowSafeArea="false" />
            </GridLayout>
            <GridLayout col="2" class="cp-expand" iosOverflowSafeArea="false">
                <Label ref="caret" class="fas" :text="'fa-caret-right' | fonticon"
                    verticalAlignment="center" horizontalAlignment="center"
                    iosOverflowSafeArea="false" />
            </GridLayout>
        </GridLayout>
        <GridLayout ref="panel" class="cp-panel" v-show="showPanel" rows="auto"
            iosOverflowSafeArea="false">
            <slot class="slot"></slot>
        </GridLayout>
    </StackLayout>
</template>

<script>
    import {
        Animation,
        Easing
    } from "@/helpers/Animation";

    export default {
        data() {
            return {
                showPanel: true,
                fixedHeight: 0
            };
        },
        props: {
            title: String,
            iconset: {
                type: String,
                default: "fa"
            },
            icon: {
                type: String,
                default: "fa-user"
            },
            backgroundColor: {
                type: String,
                default: "#eee"
            }
        },
        methods: {
            loaded() {
                if (this.fixedHeight === 0) {
                    setTimeout(() => {
                        let view = this.$refs.panel.nativeView;
                        this.fixedHeight = view.getActualSize().height;
                        if (this.fixedHeight !== 0) {
                            this.close();
                        }
                    }, 0);
                }
            },
            close() {
                let view = this.$refs.panel.nativeView;
                view.style.height = 0;
                this.showPanel = !this.showPanel;
            },
            toggle() {
                let view = this.$refs.panel.nativeView;
                let caret = this.$refs.caret.nativeView;
                if (this.showPanel) {
                    new Animation({
                            height: this.fixedHeight
                        })
                        .to({
                                height: 0
                            },
                            500
                        )
                        .easing(Easing.Back.In)
                        .onUpdate(obj => {
                            view.originY = 0;
                            view.scaleY = obj.height / this.fixedHeight;
                            view.height = obj.height;
                            caret.style.rotate =
                                (obj.height / this.fixedHeight) * 90;
                        })
                        .start()
                        .onComplete(() => (this.showPanel = !this.showPanel));
                } else {
                    this.showPanel = !this.showPanel;
                    new Animation({
                            height: 0
                        })
                        .to({
                                height: this.fixedHeight
                            },
                            500
                        )
                        .easing(Easing.Back.Out)
                        .onUpdate(obj => {
                            view.originY = 0;
                            view.scaleY = obj.height / this.fixedHeight;
                            view.height = obj.height;
                            caret.style.rotate =
                                (obj.height / this.fixedHeight) * 90;
                        })
                        .start();
                }
            }
        }
    };
</script>

<style>
    .cp-header {
        border-top-left-radius: 5;
        border-top-right-radius: 5;
    }

    .cp-header.opened {
        border-bottom-left-radius: 0;
        border-bottom-right-radius: 0;
    }

    .cp-header.closed {
        border-bottom-left-radius: 5;
        border-bottom-right-radius: 5;
    }

    .cp-icon,
    .cp-expand {
        color: #003c5a;
        font-size: 20;
    }

    .cp-title {
        color: #003c5a;
        font-size: 14;
        text-transform: uppercase;
        font-weight: bold;
    }

    .cp-panel {
        padding: 10;
        background-color: white;
        color: black;
        border-bottom-left-radius: 5;
        border-bottom-right-radius: 5;
    }
</style>